//
//  JEDownloader.h
//  JEDownloader
//
//  Copyright 2012 Jonathan Ellis
//
//  Licensed under the Apache License, Version 2.0 (the "License");
//  you may not use this file except in compliance with the License.
//  You may obtain a copy of the License at
//
//  http://www.apache.org/licenses/LICENSE-2.0
//
//  Unless required by applicable law or agreed to in writing, software
//  distributed under the License is distributed on an "AS IS" BASIS,
//  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//  See the License for the specific language governing permissions and
//  limitations under the License.
//

#import <Foundation/Foundation.h>
#import "JEDownloaderDelegate.h"
#import "NSDictionary+QueryString.h"

@interface JEDownloader : NSObject <NSURLConnectionDelegate> {
    id<JEDownloaderDelegate> __unsafe_unretained delegate;
    NSTimeInterval timeout;
    int tag;
    id context;
    NSMutableData *receivedData;
}

@property (nonatomic, unsafe_unretained) id<JEDownloaderDelegate> delegate;
@property (nonatomic, assign) NSTimeInterval timeout;
@property (nonatomic, assign) int tag;
@property (nonatomic, retain) id context;

- (void)downloadFromURL:(NSURL *)url postData:(NSDictionary *)postData;
- (void)downloadFromURL:(NSURL *)url;

@end